package sneps3.exception;

/**
 * This class defines a simple Exception scheme for the SNePS system.
 * Future versions of SNePS will likely utilize more advanced schemes.
 */
public class SnepsException extends Exception{

  /**
   * Generates a generic SNePS exception.
   * @return the created Exception.
   */
  public SnepsException(){
    super();
  }

  /**
   * Generates a SNePS exception with descriptive text.
   * Currently, the descriptive text doubles as an identifying type.
   * @return the created Exception.
   */
  public SnepsException(String s){
    super(s);
  }

}
